<?php

/*
 * PAYPAL SUBSCRIPTION MANAGER
 *
 * @package PaypalSubscriptionManager
 * @author  Michael J. Pawlowsky <mikep@mi-software.com>
 * @copyright Copyright &copy; 2005, Ultimate Internet Marketing
 * @version $Id: Db.class.php,v 1.2 2005/09/07 21:14:25 mikep Exp $;
 *
 * Created: Wed Sep 07 07:02:00 EDT 2005 07:02:00
 * Last Modified: $Date: 2005/09/07 21:14:25 $
 * Revision: $Rev:$
 *
 */


class MySQL_class {

    var $db, $id, $result, $rows, $data, $a_rows;
    var $user, $pass, $host;
    var $lastid, $err_no, $err_msg;


   /**
    * @desc Set the username, password and host for database connection
    *
    * @param text $user MySQL Username
    * @param text $pass MySQL Password
    * @param text $host MySQL Host
    */
    function Setup ($user, $pass, $host) {
        $this->user = $user;
        $this->pass = $pass;
        $this->host = $host;
    }


   /**
    * @desc Create the database connection and
    * place the database ressource id into id.
    *
    * @param text $db MySQL database name
    */
    function Create ($db = '') {

    	if($db == '' && defined('DB_NAME')){
    		$this->db = DB_NAME;
    	} else {
    		$this->db = $db;
    	}

        if (!$this->user && defined('DB_USER')) {
            $this->user = DB_USER;
        }
        if (!$this->pass && defined('DB_PASSWORD')) {
            $this->pass = DB_PASSWORD;
        }

        if (!$this->host && defined('DB_HOST')) {
            $this->host = DB_HOST;
        }

        $this->id = @mysql_pconnect($this->host, $this->user, $this->pass);
        if(!$this->id){
        	$this->err_no = @mysql_errno();
        	$this->err_msg = @mysql_error();
        } else {
        	$this->selectdb($this->db);
        }
    }



   /**
    * @desc Select the MySQL Database
    *
    * @param text $db MySQL database name
    */
    function SelectDB ($db) {
        @mysql_select_db($db, $this->id) or
            MySQL_ErrorMsg ("Unable to select database: $db");
    }


   /**
    * @desc Use this function is the query will return multiple rows.
    * Use the Fetch routine to loop through those rows.
    *
    * @param text $query SQL Query
    * @return int MySQL Error Number
    */
    function Query ($query) {
        $this->result = @mysql_query($query, $this->id);
        $this->err_no = @mysql_errno($this->id);
        $this->err_msg = @mysql_error($this->id);
        $this->rows = @mysql_num_rows($this->result);
        $this->a_rows = @mysql_affected_rows($this->id);
        return ($this->err_no);
    }


   /**
    * @desc Use this function if the query will only return a
    * single data element.
    *
    * @param text $query SQL Query
    * @return mixed The data from the SQL query
    */
    function QueryItem ($query) {
        $this->result = @mysql_query($query, $this->id);
        $this->err_no = @mysql_errno($this->id);
        $this->err_msg = @mysql_error($this->id);
        $this->rows = @mysql_num_rows($this->result);
        $this->a_rows = @mysql_affected_rows($this->id);
        $this->data = @mysql_fetch_array($this->result);
        return($this->data[0]);
    }


   /**
    * @desc This function is useful if the query will only return a
    * single row.
    *
    * @param text $query SQL Query
    * @return mixed The data from the SQL query
    */
    function QueryRow ($query) {
        $this->result = @mysql_query($query, $this->id);
        $this->err_no = @mysql_errno($this->id);
        $this->err_msg = @mysql_error($this->id);
        $this->rows = @mysql_num_rows($this->result);
        $this->a_rows = @mysql_affected_rows($this->id);
		$this->data = @mysql_fetch_array($this->result);
        return($this->data);
    }


    /**
    * @desc Fetch a row from the Query and place it into data.
    *
    * @param int $row The row to fetch
    */
    function Fetch ($row) {
        @mysql_data_seek($this->result, $row);
        $this->data = @mysql_fetch_array($this->result);
        $this->err_no = @mysql_errno($this->id);
        $this->err_msg = @mysql_error($this->id);
        return($this->err_no);
    }



    /**
    * @desc Insert a row into the database.
    *
    * @param string $query The SQL insert query.
    * @return The id of the item inserted
    */
    function Insert ($query) {
        $this->result = @mysql_query($query, $this->id);
        $this->lastid = @mysql_insert_id($this->id);
        $this->a_rows = @mysql_affected_rows($this->id);
        $this->err_no = @mysql_errno($this->id);
        $this->err_msg = @mysql_error($this->id);
        return($this->lastid);
    }

    /**
    * @desc Update a row into the database.
    *
    * @param string $query The SQL update query.
    * @return The MySQL Error number
    */
    function Update ($query) {
        $this->result = @mysql_query($query, $this->id);
        $this->a_rows = @mysql_affected_rows($this->id);
        $this->err_no = @mysql_errno($this->id);
        $this->err_msg = @mysql_error($this->id);
        return($this->err_no);
    }

     /**
    * @desc Delete a row into the database.
    *
    * @param string $query The SQL delete query.
    * @return The MySQL Error number
    */
    function Delete ($query) {
        $this->result = @mysql_query($query, $this->id);
        $this->a_rows = @mysql_affected_rows($this->id);
        $this->err_no = @mysql_errno($this->id);
        $this->err_msg = @mysql_error($this->id);
        return($this->err_no);
    }
}



/* ********************************************************************
 * MySQL_ErrorMsg
 *
 * Print out an MySQL error message
 *
 */

function MySQL_ErrorMsg ($msg, $err_no = 0) {
    # Close out a bunch of HTML constructs which might prevent
    # the HTML page from displaying the error text.
    echo("</ul></dl></ol>\n");
    echo("</table></script>\n");

    # Display the error message
    $text  = "<font color=\"#ff0000\" size=+2><p>Error " . $err_no . ":" . $msg .":";
    $text .= mysql_error();
    $text .= "</font>\n";
	$text .= "<p> <FORM><INPUT TYPE=\"Button\" VALUE=\"Back\" onClick=\"history.go(-1)\"></FORM>";
    die($text);

}


/**
* @desc Perpare data to insert into the database
*       by escaping quotes
*       and protects from SQL Injection Attacks
*       should be used for all entries into the database.
* @return string
* @param string $what The string (or number) to prepare.
*/
function prepStr ($what = "", $force_str=false)
{
	$what = trim($what);

	if(get_magic_quotes_gpc()){
		$what = stripslashes($what);
	}

	if (!is_numeric($what) || $force_str==true) {
       $what = "'" . mysql_real_escape_string($what) . "'";
    }

	return($what);
}
?>